/*********************************************
*  SCCB(=I2C)䃋[`
*  Compiler:HI-TECH C
*  PIC16F627A, 10MHz
**********************************************/
#include <htc.h>
#include "sccb.h"

/*****************************
* SCCBX^[g
*****************************/
void I2CStart(void)
{
	/* SCL,SDA͏펞HighƂ@*/
	SDA = 0;						// SDA Low
	wait();
	TRISSDA = 0;					// SDAo
}
/*****************************
* SCCBXgbv
*****************************/
void I2CStop(void)
{
	SCL = 0;						// SCL Low
	wait();
	SDA = 0;						// SDA Low
	TRISSDA = 0;					// o̓[hɖ߂@SDA =Low
	wait();
	SCL = 1;						// SCLHigh
	wait();
	SDA = 1;						// ォSDAHigh
	
}
/****************************
* SCCB1oCgo 
****************************/
void I2COut(unsigned char data)
{
	int i;
	unsigned char BitPos;

	/* Data Out */
	TRISSDA = 0;					// SDAo̓[h
	BitPos = 0x80;					// rbgʒul
	for(i=0; i<8; i++)				// 8rbgJԂ
	{
		SCL = 0;					// SCL Low
		wait();
		if((data & BitPos) != 0)	// rbgo
			SDA = 1;				// SDA High
		else
			SDA = 0;				// SDA Low
		BitPos = BitPos >> 1;		// rbgʒuړ
		wait();
		SCL = 1;					// SCL Highɖ߂
	}
	/* dummy ACK */
	wait();
	SCL = 0;						// NbNPLow
	TRISSDA = 1;					// ̓[hɂACK
	wait();
	SCL = 1;						// NbNHighɖ߂
	return;
}

/****************************
* SCCB1oCg 
****************************/
unsigned char I2CIn(void)
{
	int i;
	unsigned char BitPos;
	unsigned char data=0;

	/* Data In */
	TRISSDA = 1;					// SDA̓[h
	BitPos = 0x80;					// rbgʒul
	for(i=0; i<8; i++)				// 8rbgJԂ
	{
		SCL = 0;					// SCL Low
		wait();
		SCL = 1;					// SCL Highɖ߂
		wait();
		if(SDIN != 0)				// rbg
			data = data | BitPos;	
		BitPos = BitPos >> 1;		// rbgʒuړ
	}
	/* dummy ACK */
	wait();
	SCL = 0;						// NbNPLow
	TRISSDA = 1;					// ̓[hɂACK
	wait();
	SCL = 1;						// NbNHighɖ߂
	return(data);					// f[^߂lƂ
}

/*********************************
* Jփf[^o
*********************************/
void cam_data(unsigned char adrs, unsigned char data)
{
	I2CStart();					// X^[g
	I2COut(0x42);				// X[uAhX
	I2COut(adrs);				// WX^AhX
	I2COut(data);				// f[^o
	I2CStop();					// Xgbv
	__delay_us(30);				// x
}

/*********************************
* Jf[^ǂݍ
*********************************/
unsigned char cam_read(unsigned char adrs)
{
	unsigned char data;
	I2CStart();					// X^[g
	I2COut(0x42);				// X[uAhX(w)
	I2COut(adrs);				// WX^AhX	
	I2CStop();					// UI
	__delay_us(30);

	I2CStart();					// ʐMĊJ
	I2COut(0x43);				// X[uAhX(r)
	data = I2CIn();				// f[^
	I2CStop();					// Xgbv
	__delay_us(30);
	return(data);
}

/******************************
*  100msecx֐
******************************/
void delay_100ms(unsigned int time)
{
	time *= 4;					// 4{
	while(time){
		__delay_ms(25);			// 25msec
		time--;					// 100msec x time
	}
}

void wait(){
	__delay_us(2);
}
