/*----------------------------------------------------------------------------

     gWX^Zp@2012N3   JW[eXgvO
    STM32JpJLbg{FIFOtJW[pieNmW[j
                                                           by@c@dH
                                                           (DENKO TANAKA)
 
 -JW[tW[̏̓TvvOQlɂ܂-
 
 *----------------------------------------------------------------------------*/

//*******************************[q̗pr***************************************************
//CMOS1͖gp
//PA0 = LCD D0
//PA1 = LCD D1
//PA2 = LCD D2
//PA3 = LCD D3
//PA4 = LCD D4
//PA5 = LCD D5
//PA6 = LCD D6
//PA7 = LCD D7
//PA8 = CMOS2 D0
//PA9 = CMOS2 D1
//PA10 = CMOS2 D2
//PA11 = CMOS2 D3
//PA12 = CMOS2 D4
//PA13 = CMOS2 D5
//PA14 = CMOS2 D6
//PA15 = CMOS2 D7
//PB0 = PCLK ON
//PB1 = MCU WR
//PB2 = BL K
//PB3 = CMOS2 SCL
//PB4 = CMOS2 SDA
//PB5 = CMOS2 VSYNC
//PB6 = USART1 TX
//PB7 = USART1 RX
//PB8 = CMOS2 WEN
//PB9 = CMOS2 HREF
//PB10 =
//PB11 =
//PB12 =
//PB13 =
//PB14 =
//PB15 =
//PC0 = CMOS2 OE
//PC1 = CMOS2 RRST
//PC2 = CMOS1 SDA
//PC3 = CMOS1 SCL
//PC4 = CMOS1 CS
//PC5 = LCD RST
//PC6 = TF CS
//PC7 = LCD RD
//PC8 = LCD RS
//PC9 = LCD CS
//PC10 = USB
//PC11 = LED1
//PC12 = KEY1
//PC13 = CMOS2 RCLK
//PC14 = clk32k
//PC15 = clk32k
//PD2 = CMOS1 VSYNC

#include <stm32f10x_lib.h>
#include "STM32_Reg.h"
#include "STM32_Init.h"


#define BLACK    0x0000
#define BLUE     0x001F
#define RED      0xF800
#define GREEN    0x07E0
#define CYAN     0x07FF
#define MAGENTA  0xF81F
#define YELLOW   0xFFE0
#define WHITE    0xFFFF        

#define REGNO    168

//*********************Jpf[^*************************************************
const unsigned char OV7670_reg[REGNO][2]=
{     
    {0x3a, 0x04},
    {0x40, 0x10},
    {0x12, 0x14},
    {0x32, 0x80},
    {0x17, 0x17},
    {0x18, 0x05},
    {0x19, 0x02},
    {0x1a, 0x7b},
    {0x03, 0x0a},
    {0x0c, 0x0c},//*****10
    {0x3e, 0x00},
    {0x70, 0x00},
    {0x71, 0x01},
    {0x72, 0x11},
    {0x73, 0x09},
    {0xa2, 0x02},
    {0x11, 0xC0},
    {0x7a, 0x20},
    {0x7b, 0x1c},
    {0x7c, 0x28},//*****20
    {0x7d, 0x3c},
    {0x7e, 0x55},
    {0x7f, 0x68},
    {0x80, 0x76},
    {0x81, 0x80},
    {0x82, 0x88},
    {0x83, 0x8f},
    {0x84, 0x96},
    {0x85, 0xa3},
    {0x86, 0xaf},//*****30
    {0x87, 0xc4},
    {0x88, 0xd7},
    {0x89, 0xe8},
    {0x13, 0xe0},
    {0x00, 0x00},
    {0x10, 0x00},
    {0x0d, 0x00},
    {0x14, 0x10},
    {0xa5, 0x05},
    {0xab, 0x07},//*****40
    {0x24, 0x75},
    {0x25, 0x63},
    {0x26, 0xA5},
    {0x9f, 0x78},
    {0xa0, 0x68},
    {0xa1, 0x03},
    {0xa6, 0xdf},
    {0xa7, 0xdf},
    {0xa8, 0xf0},
    {0xa9, 0x90},//*****50
    {0xaa, 0x94},
    {0x13, 0xe5},
    {0x0e, 0x61},
    {0x0f, 0x4b},
    {0x16, 0x02},
    {0x1e, 0x37},
    {0x21, 0x02},
    {0x22, 0x91},
    {0x29, 0x07},
    {0x33, 0x0b},//*****60
    {0x35, 0x0b},
    {0x37, 0x1d},
    {0x38, 0x71},
    {0x39, 0x2a},
    {0x3c, 0x78},
    {0x4d, 0x40},
    {0x4e, 0x20},
    {0x69, 0x5d},
    {0x6b, 0x00},
    {0x74, 0x19},//*****70
    {0x8d, 0x4f},
    {0x8e, 0x00},
    {0x8f, 0x00},
    {0x90, 0x00},
    {0x91, 0x00},
    {0x92, 0x00},
    {0x93, 0x00},
    {0x96, 0x00},
    {0x9a, 0x80},
    {0xb0, 0x84},
    {0xb1, 0x0c},//*****80
    {0xb2, 0x0e},
    {0xb3, 0x82},
    {0xb8, 0x0a},
    {0x43, 0x14},
    {0x44, 0xf0},
    {0x45, 0x34},
    {0x46, 0x58},
    {0x47, 0x28},
    {0x48, 0x3a},
    {0x59, 0x88},//*****90
    {0x5a, 0x88},
    {0x5b, 0x44},
    {0x5c, 0x67},
    {0x5d, 0x49},
    {0x5e, 0x0e},
    {0x64, 0x04},
    {0x65, 0x20},
    {0x66, 0x05},
    {0x94, 0x04},
    {0x95, 0x08},//*****100
    {0x6c, 0x0a},
    {0x6d, 0x55},
    {0x6e, 0x11},
    {0x6f, 0x9f},
    {0x6a, 0x40},
    {0x13, 0xe7},
    {0x15, 0x02},
    {0x4f, 0x80},
    {0x50, 0x80},
    {0x51, 0x00},//*****110
    {0x52, 0x22},
    {0x53, 0x5e},
    {0x54, 0x80},
    {0x55, 0x00},
    {0x56, 0x60},
    {0x57, 0x90},    
    {0x58, 0x9e},    
    {0x41, 0x08},
    {0x3f, 0x05},
    {0x75, 0x05},//*****120
    {0x76, 0xe1},
    {0x4c, 0x0F},
    {0x77, 0x0a},
    {0x3d, 0xc2},
    {0x4b, 0x09},
    {0xc9, 0xc8},
    {0x41, 0x38},
    {0x34, 0x11},
    {0x3b, 0x02},
    {0xa4, 0x89},//*****130
    {0x96, 0x00},
    {0x97, 0x30},
    {0x98, 0x20},
    {0x99, 0x30},
    {0x9a, 0x84},
    {0x9b, 0x29},
    {0x9c, 0x03},
    {0x9d, 0x4c},
    {0x9e, 0x3f},
    {0x78, 0x04},//*****140
    {0x79, 0x01},
    {0xc8, 0xf0},
    {0x79, 0x0f},
    {0xc8, 0x00},
    {0x79, 0x10},
    {0xc8, 0x7e},
    {0x79, 0x0a},
    {0xc8, 0x80},
    {0x79, 0x0b},
    {0xc8, 0x01},//*****150
    {0x79, 0x0c},
    {0xc8, 0x0f},
    {0x79, 0x0d},
    {0xc8, 0x20},
    {0x79, 0x09},
    {0xc8, 0x80},
    {0x79, 0x02},
    {0xc8, 0xc0},
    {0x79, 0x03},
    {0xc8, 0x40},//*****160
    {0x79, 0x05},
    {0xc8, 0x30},
    {0x69, 0xaa},
    {0x09, 0x00},
    {0x3b, 0x42},
    {0x2d, 0x01},
};

//*******************ԑ҂֐************************************************************
// Wait(1200)100sec
void Wait(unsigned long i)
{   while( i != 0)
    {  i--;
    }
}

void delay_ms(int t)
{   Wait(t * 12000);
}

void delay_us(int t)
{   Wait(t * 12);
}

//**************J[tW[֘A******************************************************
//
void LCD_GPIO_OUTPUT(void)
{
    GPIOA->CRL = 0x33333333;//PA7-0 OUTPUT 0011
}

void LCD_GPIO_INPUT(void)
{
    GPIOA->CRL = 0x44444444;//PA7-0 INPUT 0100
}

void LCD_RD_H(void)
{
    GPIOC->BSRR = 0x00000080;//PC7 ON
}

void LCD_RD_L(void)
{
    GPIOC->BSRR = 0x00800000;//PC7 OFF
}

void LCD_CS_H(void)
{
    GPIOC->BSRR = 0x00000200;//PC9 ON
}

void LCD_CS_L(void)
{
    GPIOC->BSRR = 0x02000000;//PC9 OFF
}

void LCD_RS_H(void)
{
    GPIOC->BSRR = 0x00000100;//PC8 ON
}

void LCD_RS_L(void)
{
    GPIOC->BSRR = 0x01000000;//PC8 OFF
}

void LCD_WR_H(void)
{
    GPIOB->BSRR = 0x00020000;//PB1 OFF(not)
}

void LCD_WR_L(void)
{
    GPIOB->BSRR = 0x00000002;//PB1 ON(not)
}

void PCLK_ON_H(void)
{
    GPIOB->BSRR = 0x00000001;//PB0 ON
}

void PCLK_ON_L(void)
{
    GPIOB->BSRR = 0x00010000;//PB0 OFF
}

void CMOS_CS_H(void)
{
    GPIOC->BSRR = 0x00000010;//PC4 ON
}

void CMOS_CS_L(void)
{
    GPIOC->BSRR = 0x00100000;//PC4 OFF
}

void LCD_BL_H(void)
{
    GPIOB->BSRR = 0x00000004;//PB2 ON
}

void LCD_BL_L(void)
{
    GPIOB->BSRR = 0x00040000;//PB2 OFF
}

void LCD_RST_H(void)
{
    GPIOC->BSRR = 0x00000020;//PC5 ON
}

void LCD_RST_L(void)
{
    GPIOC->BSRR = 0x00200000;//PC5 OFF
}

void  LCD_Set_GPIO_Config(void)
{
    LCD_RD_H();
    LCD_RS_H();
    LCD_CS_H();  
    LCD_WR_H();
}

void LCD_WR_DATA16(unsigned int data)
{
    LCD_RD_H();
    LCD_RS_H();
    LCD_CS_L(); 
    
    GPIOA->ODR= (GPIOA->ODR & 0XFF00) | ((data >> 8) & 0x00FF);
    LCD_WR_L();
    LCD_WR_H();

    GPIOA->ODR= (GPIOA->ODR & 0XFF00) | (data & 0x00FF);   
    LCD_WR_L();
    LCD_WR_H();
     
    LCD_CS_H();  
}

void LCD_WR_REG16(unsigned int index)
{
    LCD_RD_H();
    LCD_RS_L();
    LCD_CS_L(); 

    GPIOA->ODR= (GPIOA->ODR & 0XFF00) | ((index >> 8) & 0x00FF);
    LCD_WR_L();
    LCD_WR_H();

    GPIOA->ODR= (GPIOA->ODR & 0XFF00) | (index & 0x00FF);      
    LCD_WR_L();
    LCD_WR_H();
    
    LCD_CS_H();
}

unsigned int LCD_RD_DATA16(void)
{
    unsigned int data;
    LCD_WR_H();
    LCD_RS_H();
    LCD_CS_L(); 

    LCD_RD_L();
    
    LCD_RD_H();
    data=0x00ff & GPIOA->IDR; 
    data=data<<8;     
     
    LCD_RD_L();
        
    LCD_RD_H();
    data|=(0x00ff & GPIOA->IDR);
    LCD_CS_H();
    return data;
}

void LCD_WR_REG(unsigned int index,unsigned int data)
{
    LCD_WR_REG16(index);
    LCD_WR_DATA16(data);
}

void LCD_Clear(unsigned int Color)
{
    unsigned long index = 0;
  
    LCD_WR_REG(0x0020,0x00ef);
    LCD_WR_REG(0x0021,0x013f);      
    
    LCD_WR_REG(0x0050,0x00);
    LCD_WR_REG(0x0051,239);
    LCD_WR_REG(0x0052,0x00);
    LCD_WR_REG(0x0053,319); 
    LCD_WR_REG16(0x0022);
  
    for(index = 0; index < 76800; index++)
    {
        LCD_WR_DATA16(Color);
    } 
}


void LCD_Init(void)
{   
    LCD_Set_GPIO_Config(); 
    LCD_GPIO_OUTPUT();
        
    LCD_BL_L(); 
    LCD_RST_H();
    delay_ms(1);
        
    CMOS_CS_H();
    PCLK_ON_L();
        
    LCD_RST_L();
    delay_ms(5);
    LCD_RST_H();
    delay_ms(1);
    LCD_WR_REG(0x0000,0x0001); 
    delay_ms(1);
    LCD_WR_REG(0x0000,0x0000); 
    LCD_WR_REG(0x0001,0x0100); 
    LCD_WR_REG(0x0002, 0x0700);
    delay_ms(5);     
    LCD_WR_REG(0x0003,0x1008);   
    LCD_WR_REG(0x0004, 0x0000);
    LCD_WR_REG(0x0008, 0x0804);
    LCD_WR_REG(0x0009, 0x0000);
    LCD_WR_REG(0x000A, 0x0000);
    LCD_WR_REG(0x000C, 0x0000);
    LCD_WR_REG(0x000D, 0x0000);
    LCD_WR_REG(0x000F, 0x0000);
    LCD_WR_REG(0x0010, 0x0000);
    LCD_WR_REG(0x0011, 0x0000);
    LCD_WR_REG(0x0012, 0x0000);
    LCD_WR_REG(0x0013, 0x0000);
   
    delay_ms(5);
    LCD_WR_REG(0x0010, 0x15b0);
    LCD_WR_REG(0x0011, 0x0227);
    delay_ms(5);
        
    LCD_WR_REG(0x0012, 0x001e);
    
    LCD_WR_REG(0x0013, 0x1600);
    LCD_WR_REG(0x0029, 0x0020);
    LCD_WR_REG(0x002B, 0x000f);
    delay_ms(100);        
    
    LCD_WR_REG(0x0020,0x00ef);
    LCD_WR_REG(0x0021,0x013f);      
    
    LCD_WR_REG(0x0030,0x0606);
    LCD_WR_REG(0x0031,0x0707);
    LCD_WR_REG(0x0032,0x0207);
    LCD_WR_REG(0x0035,0x0206);
    LCD_WR_REG(0x0036,0x0406);
    LCD_WR_REG(0x0037,0x0101);
    LCD_WR_REG(0x0038,0x0101);
    LCD_WR_REG(0x0039,0x0207);
    LCD_WR_REG(0x003C,0x0504);
    LCD_WR_REG(0x003D,0x0806);

    LCD_WR_REG(0x0050, 0x0000);
    LCD_WR_REG(0x0051, 0x00EF);
    LCD_WR_REG(0x0052, 0x0000);
    LCD_WR_REG(0x0053, 0x013F);
    LCD_WR_REG(0x0060, 0x2700);
    LCD_WR_REG(0x0061, 0x0001);
    LCD_WR_REG(0x006A, 0x0000);

    LCD_WR_REG(0x0090,(0<<7)|(16<<0));
    LCD_WR_REG(0x0092, 0x0000);
    LCD_WR_REG(0x0093, 0x0003);
    LCD_WR_REG(0x0095, 0x0110);
    LCD_WR_REG(0x0097, 0x0000);
    LCD_WR_REG(0x0098, 0x0000);

    LCD_Clear(BLACK);
    delay_ms(1);
    LCD_WR_REG(0x0007, 0x0173); 
    delay_ms(50);
     
    LCD_BL_H();
}

//******************VA|[g̐ݒ***************************************
//fobOp
void putc_COM1(unsigned char ch)//115200
{   while((USART1->SR & 0x00000080) == 0){ }// TXE ?
    USART1->DR = ((unsigned long)ch & 0x000000FF);// 8bit only
}

unsigned char getc_COM1(void)
{   while((USART1->SR & 0x00000020) == 0){ }// RXNE ?
    return((unsigned char)(USART1->DR & 0x000000FF));
}

void COM1_HS(void)
{   USART1->BRR = 0x9C;//460kbps
}

//********************************SCCB֐***********************************
//PB3 = CMOS2 SCL
//PB4 = CMOS2 SDA
//PB5 = CMOS2 VSYNC
//PB8 = CMOS2 WEN
//PB9 = CMOS2 HREF
//PC0 = CMOS2 OE
//PC1 = CMOS2 RRST
//PC13 = CMOS2 RCLK
void SCCB_RD(void)
{
    GPIOB->CRL &= 0xFFF0FFFF;//PB4 INPUT 1111 1111 1111 0000   1111 1111 1111 1111
    GPIOB->CRL |= 0x00040000;//PB4 INPUT 0000 0000 0000 0100   0000 0000 0000 0000
}

void SCCB_WR(void)
{
    GPIOB->CRL &= 0xFFF0FFFF;//PB4 OUTPUT 1111 1111 1111 0000   1111 1111 1111 1111
    GPIOB->CRL |= 0x00030000;//PB4 OUTPUT 0000 0000 0000 0011   0000 0000 0000 0000
}

void SCCB_C_H(void)
{
    GPIOB->BSRR = 0x00000008;//PB3 ON
}

void SCCB_C_L(void)
{
    GPIOB->BSRR = 0x00080000;//PB3 OFF
}

void SCCB_D_H(void)
{
    GPIOB->BSRR = 0x00000010;//PB4 ON
}

void SCCB_D_L(void)
{
    GPIOB->BSRR = 0x00100000;//PB4 OFF
}

unsigned char SCCB_D_RD(void)//PB4
{
    if((GPIOB->IDR & 0x0010) == 0) return 0x00;
    else return 0x01;
}

void startSCCB(void)
{
    SCCB_D_H();
    delay_us(500);
    SCCB_C_H();
    delay_us(500);
    SCCB_D_L();
    delay_us(500);
    SCCB_C_L();
    delay_us(500);
}

void stopSCCB(void)
{
    SCCB_D_L();
    delay_us(500);
    SCCB_C_H();    
    delay_us(500);
    SCCB_D_H();    
    delay_us(500);
}

void noAck(void)
{
    SCCB_D_H();    
    delay_us(500);
    SCCB_C_H();
    delay_us(500);
    SCCB_C_L();    
    delay_us(500);    
    SCCB_D_L();    
    delay_us(500);
}

unsigned char SCCBwriteByte(unsigned char m_data)
{
    unsigned char j,tem;

    for(j=0;j<8;j++)
    {
        if((m_data<<j)&0x80)
        {
            SCCB_D_H();    
        }
        else
        {
            SCCB_D_L();    
        }
        delay_us(500);
        SCCB_C_H();    
        delay_us(500);
        SCCB_C_L();    
        delay_us(500);

    }
    delay_us(100);
    SCCB_RD();
    delay_us(500);
    SCCB_C_H();    
    delay_us(100);
    if(SCCB_D_RD() == 1){tem=0;}
    else {tem=1;}
    SCCB_C_L();    
    delay_us(500);    
    SCCB_WR();
    return (tem);  
}

unsigned char SCCBreadByte(void)
{
    unsigned char read,j;
    read=0x00;
    
    SCCB_RD();
    delay_us(500);
    for(j = 8; j > 0; j--)
    {             
        delay_us(500);
        SCCB_C_H();
        delay_us(500);
        read=read<<1;
        if(SCCB_D_RD() == 1) 
        {
            read=read+1;
        }
        SCCB_C_L();
        delay_us(500);
    }    
    SCCB_WR();
    return(read);
}

void wr_Sensor_Reg(unsigned char regID, unsigned char regDat)
{
    startSCCB();
    SCCBwriteByte(0x42);
    delay_us(100);
    SCCBwriteByte(regID);
    delay_us(100);
    SCCBwriteByte(regDat);
    stopSCCB();
}

unsigned char rd_Sensor_Reg(unsigned char regID)
{
    unsigned char regDat;
    startSCCB();
    SCCBwriteByte(0x42);
    delay_us(100);
    SCCBwriteByte(regID);
    stopSCCB();
    delay_us(100);
    startSCCB();
    SCCBwriteByte(0x43);
    delay_us(100);
    regDat=SCCBreadByte();
    noAck();
    stopSCCB();
    return(regDat);
}

void Sensor_init(void)
{
    unsigned int i;
    wr_Sensor_Reg(0x12, 0x80);
    delay_ms(10);
    for(i = 0; i <REGNO; i++)
    {
        wr_Sensor_Reg(OV7670_reg[i][0],OV7670_reg[i][1]);
    }
} 

//*************************FIFORg[p**************************************
void WEN_H(void)
{
    GPIOB->BSRR = 0x00000100;//PB8 ON
}

void WEN_L(void)
{
    GPIOB->BSRR = 0x01000000;//PB8 OFF
}

void RRST_H(void)
{
    GPIOC->BSRR = 0x00000002;//PC1 ON
}

void RRST_L(void)
{
    GPIOC->BSRR = 0x00020000;//PC1 OFF
}

void OE_H(void)
{
    GPIOC->BSRR = 0x00000001;//PC0 ON
}

void OE_L(void)
{
    GPIOC->BSRR = 0x00010000;//PC0 OFF
}

void RCLK_H(void)
{
    GPIOC->BSRR = 0x00002000;//PC13 ON
}

void RCLK_L(void)
{
    GPIOC->BSRR = 0x20000000;//PC13 OFF
}

void LED1_OFF(void)
{
    GPIOC->BSRR = 0x00000800;//PC11 ON 0000 1000 0000 0000(ON=LED OFF)
}

void LED1_ON(void)
{
    GPIOC->BSRR = 0x08000000;//PC11 OFF 0000 1000 0000 0000(ON=LED OFF)
}

//******************************C֐*****************************************************
int main (void)
{
    unsigned int i, j, dd, r, g, b, rr ,gg, bb;
    stm32_Init ();// STM32 setup
    AFIO->MAPR &= 0x0F8FFFFF;//0b1111 1000 1111 1111 1111 1111 1111 1111    JTAG off
    AFIO->MAPR |= 0x04000000;//0b0000 0100 0000 0000 0000 0000 0000 0000
    LED1_OFF();
    Wait(12000);
    Wait(12000);
    COM1_HS();
    RRST_L();
    RRST_H();
    LCD_Init();
    //J[o[\
    LCD_WR_REG16(0x0022);
       for(i = 0; i < 30; i++)
    {    for(j = 0; j < 320; j++)
        {
            LCD_WR_DATA16(BLACK);
        }
    }
       for(i = 0; i < 30; i++)
    {    for(j = 0; j < 320; j++)
        {
            LCD_WR_DATA16(BLUE);
        }
    }
       for(i = 0; i < 30; i++)
    {    for(j = 0; j < 320; j++)
        {
            LCD_WR_DATA16(RED);
        }
    }
       for(i = 0; i < 30; i++)
    {    for(j = 0; j < 320; j++)
        {
            LCD_WR_DATA16(GREEN);
        }
    }
       for(i = 0; i < 30; i++)
    {    for(j = 0; j < 320; j++)
        {
            LCD_WR_DATA16(CYAN);
        }
    }
       for(i = 0; i < 30; i++)
    {    for(j = 0; j < 320; j++)
        {
            LCD_WR_DATA16(MAGENTA);
        }
    }
       for(i = 0; i < 30; i++)
    {    for(j = 0; j < 320; j++)
        {
            LCD_WR_DATA16(YELLOW);
        }
    }
       for(i = 0; i < 30; i++)
    {    for(j = 0; j < 320; j++)
        {
            LCD_WR_DATA16(WHITE);
        }
    }
    
    Sensor_init();
    OE_H();
    WEN_L();
    LED1_ON();
    delay_ms(50);
    WEN_H();
    LED1_OFF();
    while(1)
    {
        while((GPIOB->IDR & 0x0020) != 0) {}//VSYNC PB5
        LED1_ON();
        while((GPIOB->IDR & 0x0020) == 0) {}//VSYNC PB5
        WEN_H();
        //ŏ̉摜FIFOɕۑ̂҂
        while((GPIOB->IDR & 0x0020) != 0) {}//VSYNC PB5
        WEN_L();
        LED1_OFF();
        //ŏ̉摜tɕ\        
        OE_L();
        RRST_L();
        RCLK_L();
        RCLK_H();
        RCLK_L();
        RRST_H();
        RCLK_H();
        LCD_WR_REG16(0x0022);     
        for(i = 0; i < 240; i++)
        {    for(j = 0; j < 320; j++)
            {
                RCLK_L();
                RCLK_H();
                dd = (GPIOA->IDR >> 8) & 0x00FF;
                RCLK_L();
                RCLK_H();
                dd |= (GPIOA->IDR & 0xFF00);
                //fobOpf[^óiʐMx460kbpsj
                //putc_COM1(dd);
                //putc_COM1(dd >> 8);
                LCD_WR_DATA16(dd);
            }
        }
        OE_H();
        //҂iԂlPbɂȂ悤ɒj
        delay_ms(500);

        while((GPIOB->IDR & 0x0020) != 0) {}//VSYNC PB5
        LED1_ON();
        while((GPIOB->IDR & 0x0020) == 0) {}//VSYNC PB5
        WEN_H();
        //Qڂ̉摜FIFOɕۑ̂҂
        while((GPIOB->IDR & 0x0020) != 0) {}//VSYNC PB5
        WEN_L();
        LED1_OFF();
        //FIFÔQڂ̉摜Ɖt̍ŏ̉摜rZ
        OE_L();
        RRST_L();
        RCLK_L();
        RCLK_H();
        RCLK_L();
        RRST_H();
        RCLK_H();
        LCD_WR_REG16(0x0022);
        for(i = 0; i < 240; i++)
        {    for(j = 0; j < 320; j++)
            {
                //FIFOPf̃f[^ǂݍ
                RCLK_L();
                RCLK_H();
                dd = (GPIOA->IDR >> 8) & 0x00FF;
                RCLK_L();
                RCLK_H();
                dd |= (GPIOA->IDR & 0xFF00);    
                b = (dd >> 11) & 0x001F;
                g = (dd >> 5) & 0x003F;//bbbbbggggggrrrrr
                r = dd & 0x001F;
                //tPf̃f[^ǂݍ
                LCD_GPIO_INPUT();
                LCD_RD_DATA16();//dummy read
                dd = LCD_RD_DATA16();
                rr = ((dd >> 11) & 0x001F);//RGւ
                gg = ((dd >> 5) & 0x003F);//bbbbbggggggrrrrr
                bb = (dd & 0x001F);
                //rZƂQl
                if(rr > r)
                {   rr = rr - r; 
                }
                else
                {   rr = r - rr;
                }
                if(gg > g)
                {   gg = gg - g; 
                }
                else
                {   gg = g - gg;
                }
                if(bb > b)
                {   bb = bb - b; 
                }
                else
                {   bb = b - bb;
                }
                dd = 0;
                if((rr > 0x07) || (gg > 0x0F) || (bb > 0x07))
                {
                    dd = 0xFFFF;//Ql
                }
                //Obh̕\
                if((j == 39) || (j == 79) || (j == 119) || (j == 159) || (j == 199) || (j == 239) || (j == 279) || (i == 39) || (i == 79) || (i == 119) || (i == 159) || (i == 199))
                {
                    dd = 0x07E0;//0000 0111 1110 0000
                }
                LCD_GPIO_OUTPUT();
                LCD_WR_DATA16(dd);
            }
        }
        OE_H();
        delay_ms(500);
        delay_ms(500);
        delay_ms(500);
        delay_ms(500);
    }
}
